import hashlib
import os  # Added import for os module

# Fonction pour calculer le hash SHA-256 de la clé
def sha256(key):
    return hashlib.sha256(key.encode('utf-8')).hexdigest()

# Fonction de chiffrement XOR
def xor_encrypt(file_in, file_out, key):
    # Hachage de la clé pour augmenter la sécurité
    key = sha256(key)

    # Vérifier si le fichier d'entrée existe
    if not os.path.isfile(file_in):
        print(f"Le fichier {file_in} n'existe pas. Création d'un fichier avec un texte par défaut.")
        with open(file_in, 'wb') as f:
            f.write(b"Ceci est un texte par defaut pour le chiffrement.")

    # Ouvrir le fichier à chiffrer en mode binaire
    with open(file_in, 'rb') as f_in:
        file_data = f_in.read()
    
    # Ouvrir le fichier de sortie en mode écriture binaire
    with open(file_out, 'wb') as f_out:
        # Compteur pour indexer la clé
        counter = 0
        
        # Pour chaque byte du fichier à chiffrer
        for byte in file_data:
            # Appliquer XOR entre le byte et la clé (on fait un modulo pour répéter la clé)
            key_byte = key[counter % len(key)] #calcul de l'index de la clé
            encrypted_byte = byte ^ ord(key_byte)
            
            # Écrire le byte chiffré dans le fichier de sortie
            f_out.write(bytes([encrypted_byte]))
            
            # Incrémenter le compteur pour utiliser le prochain caractère de la clé
            counter += 1

# Demander à l'utilisateur les informations nécessaires
file_in = input("Entrez le nom du fichier à chiffrer : ")
file_out = input("Entrez le nom du fichier de sortie : ")
key = input("Entrez la clé de chiffrement : ")

# Appeler la fonction de chiffrement
xor_encrypt(file_in, file_out, key)

print(f"Le fichier {file_in} a été chiffré et enregistré sous le nom {file_out}")
